package response

import (
	"github.com/iotaledger/goshimmer/plugins/autopeering/protocol/constants"
	"github.com/iotaledger/goshimmer/plugins/autopeering/types/peer"
)

const (
	TYPE_REJECT = Type(0)
	TYPE_ACCEPT = Type(1)

	MARSHALLED_PEERS_AMOUNT  = constants.NEIGHBOR_COUNT + constants.NEIGHBOR_COUNT*constants.NEIGHBOR_COUNT
	MARHSALLED_PACKET_HEADER = 0xBC

	MARSHALLED_PACKET_HEADER_START = 0
	MARSHALLED_TYPE_START          = MARSHALLED_PACKET_HEADER_END
	MARSHALLED_ISSUER_START        = MARSHALLED_TYPE_END
	MARSHALLED_PEERS_START         = MARSHALLED_ISSUER_END
	MARSHALLED_SIGNATURE_START     = MARSHALLED_PEERS_END

	MARSHALLED_PACKET_HEADER_END = MARSHALLED_PACKET_HEADER_START + MARSHALLED_PACKET_HEADER_SIZE
	MARSHALLED_TYPE_END          = MARSHALLED_TYPE_START + MARSHALLED_TYPE_SIZE
	MARSHALLED_PEERS_END         = MARSHALLED_PEERS_START + MARSHALLED_PEERS_SIZE
	MARSHALLED_ISSUER_END        = MARSHALLED_ISSUER_START + MARSHALLED_ISSUER_SIZE
	MARSHALLED_SIGNATURE_END     = MARSHALLED_SIGNATURE_START + MARSHALLED_SIGNATURE_SIZE

	MARSHALLED_PACKET_HEADER_SIZE = 1
	MARSHALLED_TYPE_SIZE          = 1
	MARSHALLED_ISSUER_SIZE        = peer.MARSHALLED_TOTAL_SIZE
	MARSHALLED_PEER_FLAG_SIZE     = 1
	MARSHALLED_PEER_SIZE          = MARSHALLED_PEER_FLAG_SIZE + peer.MARSHALLED_TOTAL_SIZE
	MARSHALLED_PEERS_SIZE         = MARSHALLED_PEERS_AMOUNT * MARSHALLED_PEER_SIZE
	MARSHALLED_SIGNATURE_SIZE     = 65
	MARSHALLED_TOTAL_SIZE         = MARSHALLED_SIGNATURE_END
)
